/*
	IRCb Terminal.
        --------------
*/

call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

call SetBOTId 0

say
say 'BotTerm for IRCb. Type "?" for help.'
say

do forever
  call charout '','Bot-'IRCdInstant'>'
  parse pull req
  req = strip(req)
  parse upper var req cmd param
  if cmd = '?' then call Help param
  else if cmd = 'QUIT' then Exit
  else if cmd = 'BOTID' then
    if param\='' & (\datatype(param,'N') | (param<0)) then say 'Invalid ID'
    else do
      call SetBOTId param
      say 'BOT ID 'IRCdInstant
    end
  else if req\= '' then
  do
    rc = SendRequest(req)
    if rc = '/Ok' then
      do i = 1 to result.0
        say result.i
      end
    say rc
  end
end

Exit


SendRequest: procedure expose ReqPipeName result.
  rc = stream(ReqPipeName,'C','OPEN')
  Parse value rc with PipeState ':' OS2RC
  if OS2RC=3 then
    return 'Can''t send request to bot. Is it started?'
  if OS2RC=231 then 
  do
    rc = SysWaitNamedPipe(ReqPipeName,2000)
    if rc\=0 then return 'ERROR: Can''t send command to IRCb'
  end
  rc = charout(ReqPipeName,Arg(1))
  Cnt = 0
  do forever
    line = charin(ReqPipeName,,1024)
    if line = '' | left(line,1) = '/' then leave 
    Cnt = Cnt+1
    result.Cnt = line
  end
  result.0 = Cnt
  rc = stream(ReqPipeName,'C','CLOSE')
return line

SetBOTId:
  if arg(1)\='' then
  do
    IRCdInstant = arg(1)
    ReqPipeName = '\PIPE\IRCb' || IRCdInstant || '\Requests'
  end
return

Help: procedure
  Topic = arg(1)
  EOL = X2C('0D') || X2C('0A')

  T.ChanList='ChanList bot [template of channel''s name]'
  T.BotSetChan='BotSetChan bot channel'EOL'Install bot on channel.'
  T.BotDelChan='BotDelChan bot channel'EOL'Remove bot from channel.'
  T.ChanFlags='ChanFlags bot channel [flags]'EOL'Set/remove flags on channel.'
  T.ChanDenyFlags='ChanDenyFlags bot channel [flags]'EOL'Set/remove denyed flags on channel.'
  T.ChanKey='ChanKey bot channel [key]'EOL'Set/Remove key (password) on channel.'
  T.ChanLimit='ChanLimit bot channel limit'EOL'Set/Remove limit of users count on channel.'
  T.UserList='UserList bot [UserName''s template]'EOL'Get users list of bot.'
  T.User='User bot UserName'EOL'Get user''s info.'
  T.ChanUserList='ChanUserList bot channel [UserName''s template]'EOL'Get list of users for channel.'
  T.NewUser='NewUser bot UserName [password]'EOL'Create new user.'
  T.UserSetMask='UserSetMask bot UserName mask'EOL'Add mask to user.'
  T.UserDelMask='UserDelMask bot UserName mask'EOL'Remove mask for user.'
  T.DelUser='DelUser bot UserName'EOL'Remove user.'
  T.RenUser='RenUser bot UserName NewUserName'EOL'Rename user.'
  T.UserSetChan='UserSetChan bot UserName chan [flags]'EOL'Add user to channel''s users list.'
  T.UserDelChan='UserDelChan bot UserName chan'EOL'Remove user from channel''s users list.'
  T.FindUser='FindUser bot mask [UserName] [Pswd]'
  T.SendMsg='SendMsg bot recipient type "string"'EOL', recipient - user or channel; type=(Message,Notice,Action)'EOL'Send message to user or channel'
  T.StreamString='StreamString bot recipient type "string"'EOL', recipient - user or channel; type=(Message,Notice,Action)'EOL'Add message for user or channel to queue (for multiline text).'
  T.Kick='Kick bot channel nick ["comment"]'EOL'Kick Nick''s user from channel.'
  T.Invite='Invite bot channel nick'EOL'Invite Nick''s user to channel.'
  T.NewBot='NewBot bot Server Port RealName [nick]'EOL'Create a new bot'
  T.DelBot='DelBot bot'EOL'Remove the bot'
  T.Priv='Priv bot UserName newPriv'EOL'Change privileges for user'
  T.BotNick='BotNick bot NewNick'EOL'Change nickname for bot'
  T.BotSave='BotSave [bot]'EOL'Immediate save all bots / single bot'

  T = 'Help:'EOL
  T = T' BOTID [n] - setup ID. Commands will be send to IRCb with ID'EOL
  T = T' QUIT - quit form BotTerm'EOL''EOL'Commands:'EOL
  T = T' NewBot, DelBot, BotList, BotNick, BotSave, BotSetChan, BotDelChan,'
  T = T' ChanFlags,'EOL' ChanKey, ChanLimit, ChanDenyFlags, ChanList, NewUser,'
  T = T' RenUser, UserSetMask,'EOL' UserDelMask, UserList, User, FindUser,'
  T = T' DelUser, Priv, UserSetChan, 'EOL' UserDelChan, ChanUserList, SendMsg,'
  T = T' StreamString, Kick, Invite'EOL
  T = T'Type "? command"'

  say
  if Topic='' then say T
  else
    if symbol('T.Topic') = 'VAR' then say 'Syntax: 'T.Topic
    else say '- no help -'
  say
return